/*
 * Criado em 26/10/2004
 */
package br.usp.ime.coed.action.edit;

import java.awt.event.ActionEvent;
import java.util.HashSet;
import java.util.Iterator;

import br.usp.ime.coed.Main;
import br.usp.ime.coed.action.FormattedAction;
import br.usp.ime.coed.model.CoedDocumentCareTaker;
import br.usp.ime.coed.model.TransferAreaManager;
import br.usp.ime.coed.view.ApplicationView;
import br.usp.ime.coed.view.GraphicPane;
import br.usp.ime.coed.view.GraphicalIconElement;

/**
 * @author Andr Yoshiaki Kashiwabara <yoshiaki@vision.ime.usp.br>
 */
public class CutAction extends  FormattedAction{
ApplicationView view;
    /**
     * @param view
     */
    public CutAction(ApplicationView view) {
        super("Cut", 'u', Main.getInstance().getEgeneDir()
                + "/images/edit/cut.gif");


        this.view = view;

    }

    /* (non-Javadoc)
     * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent e) {
        GraphicPane pane = view.getTabPane().getSelectedGraphicPane();
        CoedDocumentCareTaker caretaker = view.getApplicationModel().getDocManager().getDocumentCareTaker(pane.getDocument());
        caretaker.addMemento(pane.getDocument().createMemento());

        TransferAreaManager tam = view.getApplicationModel().getTransferAreaManager();
        HashSet selected = new HashSet();
        Iterator it = view.getTabPane().getSelectedGraphicPane().getSelection().getSelectedElements().iterator();
        while(it.hasNext()){
            GraphicalIconElement element = (GraphicalIconElement) it.next();
            selected.add(element.getComponent());
        }
        tam.cut(selected, view.getTabPane().getSelectedDocument());
        if(selected.size() > 0){
            view.getEditMenuActions().getPaste().setEnabled(true);
        }
        view.getEditMenuActions().getCut().setEnabled(false);
        view.getEditMenuActions().getCopy().setEnabled(false);

    }

}
