/*
 * Criado em 01/11/2004
 */
package br.usp.ime.coed.utils;

import java.io.DataOutputStream;
import java.io.FileOutputStream;

import br.usp.ime.coed.Main;
import br.usp.ime.coed.model.CoedDocument;

/**
 * @author Andr Yoshiaki Kashiwabara <yoshiaki@vision.ime.usp.br>
 */
public class RunPipeline {

    private CoedDocument coed;

    private String workDirectory;

    private String stdout;

    private String stderr;

    public static final String WORKDIRECTORY = "work directory";

    public static final String STDOUT = "standard output file";

    public static final String STDERR = "standard error file";
    
 
    public void runPipeline() throws Exception {
        DataOutputStream out = new DataOutputStream(new FileOutputStream(
                workDirectory + "/pipeline.cnf"));
        out.writeBytes(coed.toString());
        out.close();
        String command = Main.getInstance().getEgeneDir()
                + "/scripts/runPipeline.sh " + workDirectory + " " + stdout
                + "  " + stderr; 
       
        Runtime run = Runtime.getRuntime();
        Process bigou = run.exec(command);
    }

    public CoedDocument getCoedDocument() {
        return coed;
    }

    public void setCoedDocument(CoedDocument coed) {
        this.coed = coed;
    }

    /**
     * @param string
     * @param text
     */
    public void setField(String string, String text) {
        if (string.equals(STDERR)) {
            stderr = text;
        } else if (string.equals(STDOUT)) {
            stdout = text;
        } else if (string.equals(WORKDIRECTORY)) {
            workDirectory = text;
        }
    }
}