package br.usp.ime.coed.DEFSupport;

class TestBuckets
/////////////////
{
  /**
   *
   * @param min    inclusive minimum
   * @param max    exclusive maximum
   * @param nBuckets
   * @param tab
   */
  private static void splitInBuckets( int min, int max, int nBuckets, String tab )
  //////////////////////////////////////////////////////////////////////////////////
  {
    int bucketSize = -1;
    if ( max - min <= nBuckets )
    {
      nBuckets = max - min;
      bucketSize = 1;
    }
    else
      bucketSize = (max - min) / nBuckets;

    for ( int i = 0; i < nBuckets; i++ )
    {
      int subMin  = min + bucketSize * i;

      // In the last sub-bucket, should include the last elements
      // that would be otherwise fall out because of the rounding off.
      int subMax = ( i == nBuckets - 1 ) ? max : (subMin + bucketSize);

      System.out.println( tab + i + ":  [ " + subMin + ", " + subMax + " )" );

      // Recursion and base.
      if ( bucketSize > 1 )
        splitInBuckets( subMin, subMax, nBuckets, tab + "  " );
    }
  }


  public static void main( String[] s )
  /////////////////////////////////////
  {
    splitInBuckets( 0, 99, 5, "" );
  }
}
