/*
 * Criado em 26/10/2004
 */
package br.usp.ime.coed.action.edit;

import java.awt.event.ActionEvent;

import br.usp.ime.coed.Main;
import br.usp.ime.coed.action.FormattedAction;
import br.usp.ime.coed.model.CoedDocumentCareTaker;
import br.usp.ime.coed.model.TransferAreaManager;
import br.usp.ime.coed.view.ApplicationView;
import br.usp.ime.coed.view.GraphicPane;

/**
 * @author Andr Yoshiaki Kashiwabara <yoshiaki@vision.ime.usp.br>
 */
public class PasteAction extends FormattedAction {
    ApplicationView view;

    /**
     * @param view
     */
    public PasteAction(ApplicationView view) {
        super("Paste", 'p', Main.getInstance().getEgeneDir()
                + "/images/edit/paste.gif");

        this.view = view;

    }

    /*
     * (non-Javadoc)
     * 
     * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent e) {
        GraphicPane pane = view.getTabPane().getSelectedGraphicPane();
        CoedDocumentCareTaker caretaker = view.getApplicationModel().getDocManager().getDocumentCareTaker(pane.getDocument());
        caretaker.addMemento(pane.getDocument().createMemento());

        TransferAreaManager tam = view.getApplicationModel()
                .getTransferAreaManager();
        tam.paste(view.getTabPane().getSelectedDocument());
        view.getEditMenuActions().getCut().setEnabled(true);
        view.getEditMenuActions().getCopy().setEnabled(true);
    }

}