/*
 * Criado em 22/10/2004
 */
package br.usp.ime.coed.action.fileMenu;

import java.awt.event.ActionEvent;

import br.usp.ime.coed.Main;
import br.usp.ime.coed.action.FormattedAction;
import br.usp.ime.coed.model.CoedDocumentManager;
import br.usp.ime.coed.view.ApplicationView;

/**
 * @author Andr Yoshiaki Kashiwabara <yoshiaki@vision.ime.usp.br>
 */
public class SaveFileAction extends FormattedAction {
    ApplicationView view;

    public SaveFileAction(ApplicationView view) {
        super("Save", 's', Main.getInstance().getEgeneDir()
                + "/images/file/save.gif");
        this.view = view;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent e) {
        try {
            CoedDocumentManager manager = view.getApplicationModel().getDocManager(); 
            manager.saveDocument();
            view.setStatus("Document " + manager.getCurrentDocument().getPath() + "/"+manager.getCurrentDocument().getName() + " saved");
        }catch (NullPointerException npe){
        	view.setStatus("Nothing to save");
        } 
        catch (Exception ioe) {
            view.setStatus(ioe.getMessage());
        } 
    }

}