/*
 * Criado em 23/10/2004
 */
package br.usp.ime.coed.action.tabbedPane;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import br.usp.ime.coed.model.CoedDocumentManager;
import br.usp.ime.coed.view.TabbedPane;

/**
 * @author Andr Yoshiaki Kashiwabara <yoshiaki@vision.ime.usp.br>
 */
public class TabbedPaneChangedAction implements ChangeListener{

    private TabbedPane pane;
    private CoedDocumentManager manager;
    public TabbedPaneChangedAction(TabbedPane pane){
        this.pane = pane;
        this.manager = pane.getDocumentManager();
    }
    /* (non-Javadoc)
     * @see javax.swing.event.ChangeListener#stateChanged(javax.swing.event.ChangeEvent)
     */
    public void stateChanged(ChangeEvent e) {
    	try{
    	    manager.setCurrentDocument(pane.getSelectedDocument());
    	    manager.getDocumentCareTaker(pane.getSelectedDocument()).notifyActive();
    	}catch(IllegalAccessError iae){
    		manager.setCurrentDocument(null);
    	}catch(NullPointerException npe){
    	    manager.setCurrentDocument(null);
    	}
    }
}
