/*
 * Created on Oct 27, 2004
 */
package br.usp.ime.coed.utils;

import java.io.File;

import javax.swing.filechooser.FileFilter;

/**
 * @author yoshiaki
 */
public class CoedFilesFilter extends FileFilter{

	/* (non-Javadoc)
	 * @see java.io.FileFilter#accept(java.io.File)
	 */
	public boolean accept(File pathname) {
	    if (pathname.isDirectory()) {
	    	return true;
	        }

	        String extension = CoedFiles.getExtension(pathname);
	        if (extension != null) {
	    	if (extension.equals(CoedFiles.COED) ) {
	    	        return true;
	    	} else {
	    	    return false;
	    	}
	        }

	        return false;
	}

	/* (non-Javadoc)
	 * @see javax.swing.filechooser.FileFilter#getDescription()
	 */
	public String getDescription() {
		return "Coed files";
	}

}
